/*
 * agenda.cpp
 *
 *  Created on: 13/mag/2013
 *      Author: bertini
 */

#include "Promemoria.h"
#include <list>
#include <vector>
#include <algorithm>
#include <iostream>

using namespace std;

int main() {
	vector<Promemoria> agenda(100);

	Promemoria azione1;
	azione1.mese = 5;
	azione1.giorno = 13;
	azione1.titolo = "Esercizio STL vector";

	Promemoria azione2;
	azione2.mese = 5;
	azione2.giorno = 13;
	azione2.titolo = "Esercizio STL multimap";

	Promemoria azione3;
	azione3.mese = 6;
	azione3.giorno = 6;
	azione3.titolo = "Ultima lezione";

	agenda.push_back(azione1);
	agenda.push_back(azione3);
	agenda.push_back(azione2);

	// Trasformando agenda da vector a list il seguente ciclo for funziona ?
	// Perche' ?
	for (unsigned int i = 0; i < agenda.size(); i++) {
		cout << agenda[1].titolo << endl;
	}

	vector<Promemoria>::iterator it;
	for (it = agenda.begin(); it != agenda.end(); it++) {
		(*it).fatto = true;
	}

	// I container di STL _copiano_ i dati inseriti: azione3 e' stato copiato e quindi la copia in vector e' modificata
	// senza la seguente linea di codice azione3 e' diversa dal contenuto del vector
	//azione3.fatto = true;
	vector<Promemoria>::iterator cercato;
	cercato = find(agenda.begin(), agenda.end(), azione3); // ricerca esaustiva: O(n)
	if (cercato == agenda.end())
		cout << "Non trovo l'elemento" << endl;
	else
		cout << (*cercato).titolo << endl;

}

